#lang racket
(require syntax/parse/define
         "survey-gui.rkt"
         "ops.rkt")

(define-simple-macro (form name clause ...)
  (begin
    (define name (make-gui 'name)) ; create a container
    (form-clause name #t clause) ...
    (send name start))) ; show the container

(define-syntax (form-clause stx)
  (syntax-parse stx
    #:literals (when)
    [(_ form-name guard-expr (when expr nested-clause ...))
     #'(begin
         (form-clause form-name (and guard-expr (?/coerce expr)) nested-clause)
         ...)]
    [(_ form-name guard-expr [id question type])
     #'(form-clause* form-name guard-expr id question type #f)]
    [(_ form-name guard-expr [id question type expr])
     #'(form-clause* form-name guard-expr id question type (lambda () expr))]))

(define-simple-macro (form-clause* form-name guard-expr id question type get-value)
  (begin
    (define id undefined)
    (gui-add! form-name ; container
              type      ; widget
              question  ; label
              (lambda () guard-expr)   ; guard
              (lambda (v) (set! id v)) ; set value
              get-value)))             ; get value for read-only, #f otherwise

; ----------------------------------------

(form Box1HouseOwning
      [hasSoldHouse "Did you sell a house in 2010?" boolean-widget]
      [hasBoughtHouse "Did you by a house in 2010?" boolean-widget]
      [hasMaintLoan "Did you enter a loan for maintenance/reconstruction?" boolean-widget]
 
      (when hasSoldHouse
        [sellingPrice "Price the house was sold for:" money-widget]
        [privateDebt "Private debts for the sold house:" money-widget]
        [valueResidue "Value residue:" money-widget (-/coerce sellingPrice privateDebt)]))

