#lang racket
(require syntax/parse/define
         "survey-gui.rkt"
         "ops.rkt")

(provide form
         
         (rename-out [boolean-widget boolean]
                     [money-widget money])
         
         (rename-out [-/coerce -]
                     [>/coerce >]
                     [</coerce <]
                     [=/coerce =]
                     [and/coerce and]
                     [or/coerce or]))

;; ----------------------------------------

(define-simple-macro (form name clause ...)
  (begin
    (define name (make-gui 'name))
    (form-clause name #t clause) ...
    (send name start)))

(define-syntax (form-clause stx)
  (syntax-parse stx
    #:literals (when)
    [(_ form-name guard-expr (when expr nested-clause ...))
     #'(begin
         (form-clause form-name (and guard-expr (?/coerce expr)) nested-clause)
         ...)]
    [(_ form-name guard-expr [id question type])
     #'(form-clause* form-name guard-expr id question type #f)]
    [(_ form-name guard-expr [id question type expr])
     #'(form-clause* form-name guard-expr id question type (lambda () expr))]))

(define-simple-macro (form-clause* form-name guard-expr id question type get-value)
  (begin
    (define id undefined)
    (gui-add! form-name
              type
              question
              (lambda () guard-expr)
              (lambda (v) (set! id v))
              get-value)))
