#lang racket
(require syntax/parse/define
         "survey-gui.rkt"
         "ops.rkt")

(provide form
         
         (rename-out [boolean-widget boolean]
                     [money-widget money])
         
         when
         #%app
         #%datum
         
         #%module-begin)

(provide-ops)

;; ----------------------------------------

(define-simple-macro (form name clause ...)
  (begin
    (define name (make-gui 'name))
    (form-clause name (lambda () #t) clause) ...
    (send name start)))

(define-syntax (form-clause stx)
  (syntax-parse stx
    #:literals (when)
    [(_ form-name guard-proc (when expr nested-clause ...))
     #'(begin
         (define new-guard-proc (lambda () (and (guard-proc) (?/coerce expr))))
         (form-clause form-name new-guard-proc nested-clause)
       ...)]
    [(_ form-name guard-proc [id question type])
     #'(form-clause* form-name guard-proc id question type #f)]
    [(_ form-name guard-proc [id question type expr])
     #'(form-clause* form-name guard-proc id question type (lambda () expr))]))
    
(define-simple-macro (form-clause* form-name guard-proc id:id question type get-value)
  (begin
    (define id undefined)
    (gui-add! form-name
              type
              question
              guard-proc
              (lambda (v) (set! id v))
              get-value)))
